SystemOrganization addCategory: #ConfigurationOfAggregate!

Object subclass: #ConfigurationOfAggregate
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfAggregate'!

!ConfigurationOfAggregate class methodsFor: 'development support' stamp: 'sebastiansastre 3/4/2014 10:47'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfAggregate class methodsFor: 'private' stamp: 'sebastiansastre 3/4/2014 10:47'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfAggregate class methodsFor: 'catalog' stamp: 'sebastiansastre 3/5/2014 19:14'!
catalogChangeLog
	^ '
Date: March 5, 2014

First Aggregate configuration using github

'! !

!ConfigurationOfAggregate class methodsFor: 'catalog' stamp: 'sebastiansastre 3/4/2014 10:54'!
catalogContactInfo
	^ 'https://github.com/sebastianconcept'! !

!ConfigurationOfAggregate class methodsFor: 'catalog' stamp: 'sebastiansastre 3/5/2014 19:15'!
catalogDescription
	^ 'Aggregate is a small persistance framework with a clean API that uses OmniBase as backend.'! !

!ConfigurationOfAggregate class methodsFor: 'catalog' stamp: 'sebastiansastre 3/5/2014 19:15'!
catalogKeyClassesAndExample
	^ '
Aggregate


'! !

!ConfigurationOfAggregate class methodsFor: 'catalog' stamp: 'sebastiansastre 3/4/2014 11:56'!
catalogKeywords
	^ #(#Database #Persistence)! !

!ConfigurationOfAggregate class methodsFor: 'gitfiletree support' stamp: 'sebastiansastre 3/4/2014 10:47'!
ensureGitFileTree
	"And all related dependencies."

	Smalltalk
		at: #MCFileTreeGitRepository
		ifAbsent: [ 
			Gofer new
				url: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo30/main';
				configurationOf: 'GitFileTree';
				loadDevelopment ]! !

!ConfigurationOfAggregate class methodsFor: 'private' stamp: 'sebastiansastre 3/4/2014 10:47'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfAggregate class methodsFor: 'private' stamp: 'sebastiansastre 3/4/2014 10:47'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfAggregate class methodsFor: 'metacello tool support' stamp: 'sebastiansastre 3/4/2014 10:47'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfAggregate class methodsFor: 'loading' stamp: 'sebastiansastre 3/4/2014 10:47'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfAggregate class methodsFor: 'loading' stamp: 'sebastiansastre 3/4/2014 10:47'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfAggregate class methodsFor: 'accessing' stamp: 'sebastiansastre 3/4/2014 10:47'!
project

	^self new project! !

!ConfigurationOfAggregate class methodsFor: 'development support' stamp: 'sebastiansastre 3/4/2014 10:47'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfAggregate methodsFor: 'accessing' stamp: 'sebastiansastre 3/5/2014 19:11'!
baseline10: spec
    <version: '1.0-baseline'>
    
	spec for: #'pharo3.x' do: [
		spec blessing: #baseline.

		spec project: 'OmniBase' with: [ spec
				className: 'ConfigurationOfOmniBase';
				file: 'ConfigurationOfOmniBase';
				repository: 'http://squeaksource.com/MetacelloRepository'.
				].
	]
! !

!ConfigurationOfAggregate methodsFor: 'accessing' stamp: 'sebastiansastre 3/5/2014 20:00'!
baseline11: spec
    <version: '1.1-baseline'>
    
	spec for: #'pharo3.x' do: [
		self class ensureGitFileTree.
		spec blessing: #baseline.

		spec
			repository: 'http://www.squeaksource.com/BTree';
			package: 'Collections-BTree'.

		spec project: 'OmniBase' with: [ spec
				className: 'ConfigurationOfOmniBase';
				file: 'ConfigurationOfOmniBase';
				repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo30/main'.
				].
	]
! !

!ConfigurationOfAggregate methodsFor: 'accessing' stamp: 'sebastiansastre 3/4/2014 10:47'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfAggregate methodsFor: 'accessing' stamp: 'sebastiansastre 3/4/2014 10:47'!
project
	^ project
		ifNil: [ 
			| constructor |
				"Bootstrap Metacello if it is not already loaded"
			(self class baseConfigurationClassIfAbsent: [  ]) ensureMetacello.
				"Construct Metacello project"
			project := MetacelloMCProject new projectAttributes: self customProjectAttributes.
			constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
			project loadType: #linear.	"change to #atomic if desired"
			project ]! !

!ConfigurationOfAggregate methodsFor: 'symbolic versions' stamp: 'sebastiansastre 3/5/2014 17:34'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'pharo3.x' version: '1.1'
! !

!ConfigurationOfAggregate methodsFor: 'accessing' stamp: 'sebastiansastre 3/5/2014 19:11'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec
		for: #'pharo3.x'
		do: [ 
			spec
				blessing: #release;
				author: 'sebastianconcept';
				repository: 'gitfiletree://github.com/sebastianconcept/Aggregate.git?protocol=git&branch=Pharo3.0&dir=src';
				description: 'Aggregate is a small persistance framework with a clean API that uses OmniBase as backend.'.

			spec package: 'Aggregate'.
			 ].
! !

!ConfigurationOfAggregate methodsFor: 'accessing' stamp: 'sebastiansastre 3/5/2014 19:11'!
version11: spec
	<version: '1.1' imports: #('1.1-baseline')>

	spec
		for: #'pharo3.x'
		do: [ 
			spec
				blessing: #release;
				author: 'sebastianconcept';
				repository: 'gitfiletree://github.com/sebastianconcept/Aggregate.git?protocol=git&branch=Pharo3.0&dir=src';
				description: 'Aggregate is a small persistance framework with a clean API that uses OmniBase as backend.'.

			spec package: 'Aggregate'.
			 ].
! !
